/* Zaklady programovani v C++
   Okomentovane priklady ze cviceni ... ukazatele (uvod)
*/

#include<iostream>
#include<string>
using namespace std;

/* Ukazka prace s ukazateli*/
void ukazatele()
{
	cout << "Priklady na ukazatele:" << endl;
	int i = 3;
	cout << "adresa promenne i v pameti je " << &i << endl;
	cout << "velikost datoveho typu int je " << sizeof(int) << " a int* je " << sizeof(int*) << endl;
	int j = (int)(&i);  // adresa jako cislo v desitkove soustave
	cout << "adresa promenne i v desitkove soustave je "  << j << endl;

	// deklarace promenne typu ukazatel:
	int *pi;         // pi je ukazatel na datovy typ int
	pi = &i;         // do ukazatele pi vlozime adresu i
	int *pj = &i;    // deklarace ukazatele pj a jeho inicializace na adresu i
	double *pd, *pe; // deklarace dvou ukazatelu na double (bez inicializace)

	int k = (int)(pi); //adresa i jako cislo v desitkove soustave

	cout << "\nAdresa a hodnota promenne i:" << endl;
	cout << &i << " "; // vytiskne adresu promenne i v pameti
	cout << pi << " "; // vytiskne adresu promenne i v pameti

	cout << i << " ";   // vytiskne hodnotu promenne i
	cout << *pi << endl; // vytiskne hodnotu promenne i

	cout << "\nPrace s ukazateli:" << endl;
	*pi = 10;        // do promenne i vlozime hodnotu 10
	// i = 10        // totez
	cout << i << " " << *pi << endl;

	j = 5;
	*pi = *pi + j;   // v promenne i bude hodnota 10+5==15
	// i = i + j;    // totez
	cout << i << " " << *pi << endl;

	pi = &j;         // do ukazatele pi vlozime adresu j
	(*pi)++;         // v promenne j bude hodnota 6
	// j++           // totez
	cout << i << " " << j << " " << *pi << endl;

	pi = nullptr;
	cout << pi << endl;
	// cout << *pi << endl; // chyba!
	if (pi)
		cout << *pi << endl;

	// void
	i = 1, j = 2;
	pi = &i;
	void *v = &j;
	v = pi;
	pi = (int*)v;
	// j = (*v) + 4; chyba!, nelze dereferencovat
	j = (*pi) + 4;

}


void vypis(int x)
{
	cout << "1: Adresa a hodnota promenne uvnitr funkce jsou " << &x << " a " << x << endl;
}

void vypis(int *px)
{
	cout << "2: Adresa a hodnota promenne uvnitr funkce jsou " << px << " a " << *px << endl;
}

void zmen(int x)
{
	x++;
	cout << "1: Hodnota promenne uvnitr funkce je " << x << endl;
}

void zmen(int *px)
{
	(*px)++;
	cout << "2: Hodnota promenne uvnitr funkce je " << *px << endl;
}


void neprohod(int a, int b)
{
	int c = a;
	a = b;
	b = c;
	cout << "uvnitr funkce: a a b jsou " << a << " a " << b << endl;
}


void ukazatele_a_funkce()
{
	cout << "Priklady na ukazatele a funkce:" << endl;
	int a = 5;
	int *pa = &a;
	vypis(a);
	vypis(*pa);
	vypis(&a);
	vypis(pa);
	cout << "0: Adresa a hodnota promenne venku jsou " << &a << " a " << a << endl;

	zmen(a);
	cout << "Hodnota promenne venku je " << a << endl;
	zmen(*pa);
	cout << "Hodnota promenne venku je " << a << endl;
	zmen(&a);
	cout << "Hodnota promenne venku je " << a << endl;
	zmen(pa);
	cout << "Hodnota promenne venku je " << a << endl;

	int b = 1;
	cout << "a a b jsou " << a << " a " << b << endl;
	neprohod(a, b);
	cout << "a a b jsou " << a << " a " << b << endl;

}

int main()
{
	ukazatele();
	ukazatele_a_funkce();
	return 0;
}